﻿using Syncfusion.Windows.Shared;
using Syncfusion.UI.Xaml.NavigationDrawer;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Diagnostics;
using System.Windows.Data;
using System.Windows;
using System.Linq;
using System.Management;
using System.Text;
using System.Windows.Controls;
using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Utility;
using System.Threading.Tasks;
using System.Windows.Input;
using XGApp.Utils;
using XGApp.Model;
using System.Windows.Media.Imaging;
using Syncfusion.UI.Xaml.Controls.DataPager;
using XGApp.Properties;

namespace XGApp.ViewModel
{
    public class NavigationDrawerProperties : NotificationObject, IDisposable
    {

       
        private int _StatisticPageIndex { get; set; }
        public int StatisticPageIndex
        {
            get
            {
                return _StatisticPageIndex;

            }
            set
            {
                _StatisticPageIndex = value;
                RaisePropertyChanged("StatisticPageIndex");
            }
        }
        private int _CountOnPage { get; set; }
        public int CountOnPage
        {
            get
            {
                return _CountOnPage;

            }
            set
            {
                _CountOnPage = value;
                RaisePropertyChanged("CountOnPage");
            }
        }
        private int _PageCountPin { get; set; }
        public int PageCountPin
        {
            get
            {
                return _PageCountPin;

            }
            set
            {
                _PageCountPin = value;
                RaisePropertyChanged("PageCountPin");
            }
        }
        private int _PageCountSbo { get; set; }
        public int PageCountSbo
        {
            get
            {
                return _PageCountSbo;

            }
            set
            {
                _PageCountSbo = value;
                RaisePropertyChanged("PageCountSbo");
            }
        }
        public NavigationDrawerProperties()
        {
            StatisticPageIndex = 0;
            CountOnPage = 15;

            onDemandLoadingPinCommand = new RelayCommand(OnDemandLoadingPin);
            onDemandLoadingSboCommand = new RelayCommand(OnDemandLoadingSbo);

            
            _saveCommand = new RelayCommand(SaveObject, CanSave);

            rowDataCommand = new RelayCommand(ChangeCanExecute);


        }
        private bool canNavigate { get; set; }

        public bool CanNavigate
        {
            get { return canNavigate; }
            set
            {
                canNavigate = value;
                RaisePropertyChanged("CanNavigate");
            }
        }
        private void ShowFaq(object obj)
        {
            Process.Start("https://xscore.win/faq/");
            //SelectedIndex = -1;
            //IsProfileVisibility = false;
            //statPageVisibility = false;
            //resultPageVisibility = false;
            //IsFilterVisibility = false;
            //IsFaqVisibility = true;
        }
        public async void OnDemandLoadingPin(object sender, OnDemandLoadingEventArgs args)
        {


            if (CurrentFilters == null)
            {
                StatistickPinnacle = new ObservableCollection<StatisctickView>(new List<StatisctickView>() { new StatisctickView() { P2 = 0, P1 = 0, H = 0, Match = "Пусто - Пусто", XG = "" } });
            }
            else
            {
                CurrentFilters.SKip = args.StartIndex;
                CurrentFilters.Count = args.PageSize;
                var resultPage = await Api.GetStatistick(CurrentFilters);
                if (sender is SfDataPager sfDataPager && resultPage!= null)
                {
                    var items = resultPage.Pinacle;
                    PageCountPin = resultPage.PageInfoPin.TotalPage;
                    sfDataPager.LoadDynamicItems(args.StartIndex, items);
                }

            }
        }

        public async void OnDemandLoadingSbo(object sender, OnDemandLoadingEventArgs args)
        {



            if (CurrentFilters == null)
            {
                StatistickSbobet = new ObservableCollection<StatisctickView>(new List<StatisctickView>() { new StatisctickView() { P2 = 0, P1 = 0, H = 0, Match = "Пусто - Пусто", XG = "" } });
            }
            else
            {
                CurrentFilters.SKip = args.StartIndex;
                CurrentFilters.Count = args.PageSize;
                var resultPage = await Api.GetStatistick(CurrentFilters);
                if (sender is SfDataPager sfDataPager && resultPage != null)
                {
                    var items = resultPage.Sbobet;
                    //PageCountSbo = resultPage.PageInfoSbo.TotalPage;
                    sfDataPager.LoadDynamicItems(args.StartIndex, items);
                }

            }
        }



        #region ButtonFilterCommand




        private ICommand onDemandLoadingSboCommand;
        public ICommand OnDemandLoadingSboCommand
        {
            get
            {
                return onDemandLoadingSboCommand;
            }
        }

        private ICommand onDemandLoadingPinCommand;
        public ICommand OnDemandLoadingPinCommand
        {
            get
            {
                return onDemandLoadingPinCommand;
            }
        }
        


        





       

        
        
      
       


        private ICommand _saveCommand;

        public ICommand SaveCommand
        {
            get
            {
                return _saveCommand;
            }
        }
        
        private bool CanSave(object obg)
        {
           
            return true;
        }
        public ModelFilterStatistic CurrentFilters { get; set; }
        private async void SaveObject(object obg)
        {
            PanelLoading = true;
            CurrentFilters = new ModelFilterStatistic();
            CurrentFilters.SKip = 0;
            CurrentFilters.Count = CountOnPage;

            var result = await Api.GetResultPage(CurrentFilters);
            if (result.Statistic.Pinacle == null || result.Statistic.Pinacle.Count == 0)
            {
                MessageBox.Show("Фильтр не дал результатов. Измените фильтр");
                PanelLoading = false;
                return;
            }

            PageCountPin = result.Statistic.PageInfoPin.TotalPage;
            StatistickPinnacle = new ObservableCollection<StatisctickView>(result.Statistic.Pinacle);
            if (StatistickPinnacle == null || StatistickPinnacle.Count == 0)
            {
                MessageBox.Show("Фильтр не дал результатов. Измените фильтр");
                PanelLoading = false;
                return;
            }
            if (result.Statistic.Sbobet == null || result.Statistic.Sbobet.Count == 0)
            {
                MessageBox.Show("Фильтр не дал результатов. Измените фильтр");
                PanelLoading = false;
                return;
            }
            PageCountSbo = result.Statistic.PageInfoSbo.TotalPage;
            StatistickSbobet = new ObservableCollection<StatisctickView>(result.Statistic.Sbobet);
           
            CanNavigate = true;
            PanelLoading = false;
            SelectedIndex = 1;


        }

        #endregion
        private int _selectedIndex { get; set; }
        public int SelectedIndex
        {
            get
            {
                switch (_selectedIndex)
                {
                    case 0:
                        IsProfileVisibility = false;
                        statPageVisibility = false;
                        resultPageVisibility = false;
                        IsFilterVisibility = true;
                        IsFaqVisibility = false;
                        break;
                    case 1:
                        if (StatistickPinnacle == null || StatistickPinnacle.Count == 0 || StatistickPinnacle == null || StatistickPinnacle.Count == 0)
                        {
                            //_selectedIndex = 0;
                            //IsProfileVisibility = false;
                            //statPageVisibility = false;
                            //resultPageVisibility = false;
                            //IsFilterVisibility = true;
                            //return _selectedIndex;
                        }
                        if (IsPinStat == false && IsSbobetStat == false)
                        {
                            IsPinStat = true;
                        }
                        IsProfileVisibility = false;
                        IsFilterVisibility = false;
                        resultPageVisibility = false;
                        statPageVisibility = true;
                        IsFaqVisibility = false;
                        break;
                    case 2:
                        if (Performance == null || Performance.Count == 0)
                        {
                            //_selectedIndex = 0;
                            //IsProfileVisibility = false;
                            //statPageVisibility = false;
                            //resultPageVisibility = false;
                            //IsFilterVisibility = true;
                            //return _selectedIndex;
                        }
                        IsProfileVisibility = false;
                        IsFilterVisibility = false;
                        statPageVisibility = false;
                        resultPageVisibility = true;
                        IsFaqVisibility = false;
                        break;
                }
                return _selectedIndex;
            }

            set
            {
                if (_selectedIndex == value)
                {
                    return;
                }

                // At this point _selectedIndex is the old selected item's index

                _selectedIndex = value;





                // At this point _selectedIndex is the new selected item's index

                RaisePropertyChanged(() => SelectedIndex);
            }
        }


       

        private bool _IsPinStat { get; set; }
        public bool IsPinStat
        {
            get
            {
                return _IsPinStat;
            }
            set
            {
                _IsPinStat = value;
                RaisePropertyChanged("IsPinStat");
            }
        }

        private bool _IsSbobetStat { get; set; }
        public bool IsSbobetStat
        {
            get
            {
                return _IsSbobetStat;
            }
            set
            {
                _IsSbobetStat = value;
                RaisePropertyChanged("IsSbobetStat");
            }
        }

        public void ChangeStat(string type)
        {
            switch (type)
            {
                case "pin":
                    IsSbobetStat = false;
                    IsPinStat = true;

                    break;
                case "sbo":

                    IsPinStat = false;
                    IsSbobetStat = true;
                    break;
            }
        }
        public void ChangeCanExecute(object obj)
        {
            var rowdataContent = (obj as StatisctickView);
            if (rowdataContent != null && !string.IsNullOrEmpty(rowdataContent.XG))
            {
                if (!string.IsNullOrEmpty(rowdataContent.XG))
                {
                    Process.Start(rowdataContent.XG);
                }
            }
        }

        private double GetRandomNumber(double minimum, double maximum)
        {
            Random random = new Random();
            return random.NextDouble() * (maximum - minimum) + minimum;
        }

        public void Dispose()
        {
            if (StatistickPinnacle != null)
                StatistickPinnacle.Clear();
            if (StatistickSbobet != null)
                StatistickSbobet.Clear();
            if (Performance != null)
                Performance.Clear();
            if (ROIBase != null)
                ROIBase.Clear();
            if (Contents != null)
                Contents.Clear();
            if (OutcomeProbabilities != null)
                OutcomeProbabilities.Clear();
            if (ROITotal != null)
                ROITotal.Clear();
            if (PinClose != null)
                PinClose.Clear();
            if (PinOpening != null)
                PinOpening.Clear();
        }



       

        private ObservableCollection<StatisctickView> statistick;
        public ObservableCollection<StatisctickView> Statistick
        {
            get { return statistick; }
            set { statistick = value; RaisePropertyChanged("Statistick"); }
        }

        private ObservableCollection<StatisctickView> statistickPinnacle;
        public ObservableCollection<StatisctickView> StatistickPinnacle
        {
            get { return statistickPinnacle; }
            set { statistickPinnacle = value; RaisePropertyChanged("StatistickPinnacle"); }
        }
        private ObservableCollection<StatisctickView> statistickSbobet;
        public ObservableCollection<StatisctickView> StatistickSbobet
        {
            get { return statistickSbobet; }
            set { statistickSbobet = value; RaisePropertyChanged("StatistickSbobet"); }
        }

      

        private ObservableCollection<FilterItem> xgFiltersSelected;
        public ObservableCollection<FilterItem> XgFiltersSelected
        {
            get { return xgFiltersSelected; }
            set { xgFiltersSelected = value; RaisePropertyChanged("XgFiltersSelected"); }
        }






        private bool _panelLoading;
        private string _panelMainMessage = "Выполняется расчет";
        private string _panelSubMessage = "Подождите немного...";

        public bool PanelLoading
        {
            get
            {
                return _panelLoading;
            }
            set
            {
                _panelLoading = value;
                RaisePropertyChanged("PanelLoading");
            }
        }

        /// <summary>
        /// Gets or sets the panel main message.
        /// </summary>
        /// <value>The panel main message.</value>
        public string PanelMainMessage
        {
            get
            {
                return _panelMainMessage;
            }
            set
            {
                _panelMainMessage = value;
                RaisePropertyChanged("PanelMainMessage");
            }
        }

        /// <summary>
        /// Gets or sets the panel sub message.
        /// </summary>
        /// <value>The panel sub message.</value>
        public string PanelSubMessage
        {
            get
            {
                return _panelSubMessage;
            }
            set
            {
                _panelSubMessage = value;
                RaisePropertyChanged("PanelSubMessage");
            }
        }




        //FilterItem
    }

    public class ListContent : NotificationObject
    {
        private string name;
        private string content;
        public string Name
        {
            get { return name; }
            set { name = value; RaisePropertyChanged("Name"); }
        }

        public string Content
        {
            get { return content; }
            set { content = value; RaisePropertyChanged("Content"); }
        }
    }

    public class PageInfo
    {
        public int TotalPage { get; set; }
        public int SKip { get; set; }
        public int Count { get; set; }
    }

    public class StatisctickViewPagination
    {
        public PageInfo PageInfoSbo { get; set; }
        public PageInfo PageInfoPin { get; set; }
        public List<StatisctickView> Sbobet { get; set; }
        public List<StatisctickView> Pinacle { get; set; }
    }
    public class StatisctickView
    {
        public string Match { get; set; }
        public double? P1 { get; set; }
        public double? H { get; set; }
        public double? P2 { get; set; }
        public string XG { get; set; }

        private BaseCommand _TestCommand;
        public BaseCommand TestCommand
        {
            get
            {
                if (_TestCommand == null)
                    _TestCommand = new BaseCommand(TestAction);
                return _TestCommand;
            }
        }

        public void TestAction(object param)
        {

            MessageBox.Show(param.ToString());
        }

    }













    public class Result1 : BasicResutl
    {
        private string name;

        [Display(Name = "Результатисность", Description = "")]
        public string Name
        {
            get { return name; }
            set { name = value; RaisePropertyChanged("Name"); }
        }

    }
    public class Result2 : BasicResutl
    {
        private string name;

        [Display(Name = "ROI основных рынков", Description = "")]
        public string Name
        {
            get { return name; }
            set { name = value; RaisePropertyChanged("Name"); }
        }

    }
    public class Result3 : BasicResutl
    {
        private string name;

        [Display(Name = "Вероятности исходов", Description = "")]
        public string Name
        {
            get { return name; }
            set { name = value; RaisePropertyChanged("Name"); }
        }

    }
    public class Result4 : BasicResutl
    {
        private string name;

        [Display(Name = "ROI тоталов", Description = "")]
        public string Name
        {
            get { return name; }
            set { name = value; RaisePropertyChanged("Name"); }
        }

    }
    public class Result5 : BasicResutl
    {
        private string name;

        [Display(Name = "Профит линии открытия Pin", Description = "")]
        public string Name
        {
            get { return name; }
            set { name = value; RaisePropertyChanged("Name"); }
        }

        private int count;

        [Display(Name = "Кол-во ставок", Description = "")]
        public int Count
        {
            get { return count; }
            set { count = value; RaisePropertyChanged("Count"); }
        }

    }
    public class Result6 : BasicResutl
    {
        private string name;

        [Display(Name = "Профит линии закрытия Pin+SBO", Description = "")]
        public string Name
        {
            get { return name; }
            set { name = value; RaisePropertyChanged("Name"); }
        }
        private int count;

        [Display(Name = "Кол-во ставок", Description = "")]
        public int Count
        {
            get { return count; }
            set { count = value; RaisePropertyChanged("Count"); }
        }
    }


    public class BasicResutl : NotificationObject
    {
        public BasicResutl()
        {
            isNew = true;
        }
        private bool isNew { get; set; }

        private double _value;
        private double _oldValue;
        private double subtract;
        [Display(Name = "Результат", Description = "")]
        public double Value
        {
            get { return _value; }
            set { _value = value; RaisePropertyChanged("Value"); RaisePropertyChanged("Subtract"); }
        }
        [Display(Name = "Сравнение", Description = "")]
        public double OldValue
        {
            get { return _oldValue; }
            set
            {
                _oldValue = value; RaisePropertyChanged("OldValue");
                isNew = false;
            }
        }
        [Display(Name = "Изменение", Description = "")]
        public double Subtract
        {
            get
            {
                if (isNew)
                    return 0;

                return Math.Round(Value - OldValue, 2);

            }

        }
    }


    public class SelectorClass : StyleSelector
    {

        public override Style SelectStyle(object item, DependencyObject container)
        {
            var data = item as BasicResutl;

            if (data != null && ((container as GridCell).ColumnBase.GridColumn.MappingName == "Value"))
            {

                //custom condition is checked based on data.

                if (data.Subtract < 0)
                    return App.Current.Resources["redCellStyle"] as Style;
                return base.SelectStyle(item, container);
            }
            return base.SelectStyle(item, container);
        }
    }


    public class FilterItem : NotificationObject
    {
        public FilterItem()
        {
            ListProperty = new ObservableCollection<SelectableParam>();
        }
        public string FilterType { get; set; }
        public bool IsSelect { get; set; }
        public string Name { get; set; }
        public string NameDb { get; set; }
        private int type { get; set; }
        public int Type
        {
            get
            {
                return type;
            }
            set
            {
                type = value;
            }
        }
        public double MinValue { get; set; }
        public double MaxValue { get; set; }

        private double _min { get; set; }
        private double _max { get; set; }
        public double Min
        {
            get
            {
                return _min;
            }
            set
            {
                if (MinValue > value)
                {
                    _min = MinValue;
                }
                else
                {
                    if (MaxValue < value && MaxValue != 0)
                    {
                        _min = MaxValue;
                    }
                    else
                    {
                        _min = value;
                    }
                }

                RaisePropertyChanged("Min");
            }
        }
        public double Max
        {
            get
            {
                return _max;
            }
            set
            {
                if ((MaxValue < value && MaxValue != 0))
                {
                    _max = MaxValue;
                }
                else
                {
                    if (MinValue > value && MinValue != 0)
                    {
                        _max = MinValue;
                    }
                    else
                    {
                        _max = value;
                    }
                }

                if (Min > _max)
                {
                    _max = Min;
                }

                RaisePropertyChanged("Max");
            }
        }

        public string MinTime { get; set; }
        public string MaxTime { get; set; }

        private ObservableCollection<SelectableParam> listProperty;
        public ObservableCollection<SelectableParam> ListProperty
        {
            get
            {
                return listProperty;
            }
            set
            {
                listProperty = value;
                RaisePropertyChanged("ListProperty");
            }
        }
    }
    public class SelectableParam
    {
        public bool Checked { get; set; }
        public string Name { get; set; }
        public int Id { get; set; }
    }

    public class SelectableParamLeague : SelectableParam
    {
        public string GroupName { get; set; }
        public int CountryId { get; set; }
    }
    public class SelectableParamSeason : SelectableParam
    {
        public int CountryId { get; set; }
        public int LeagueId { get; set; }

    }

    public class SelectableParamTeam : SelectableParam
    {
        public int CountryId { get; set; }
        public int LeagueId { get; set; }
        public int SeasonId { get; set; }
    }

    public class FilterStyleSelector : StyleSelector
    {
        public Style NumberClassStyle { get; set; }
        public Style ListHomeClassStyle { get; set; }
        public Style ListAwwayClassStyle { get; set; }
        public Style TimeClassStyle { get; set; }
        public Style ListCountryStyle { get; set; }
        public Style ListLegueStyle { get; set; }

        public Style ListSeasonStyle { get; set; }

        public override Style SelectStyle(object item, DependencyObject container)
        {
            FilterItem filter = (FilterItem)item;

            switch (filter.Type)
            {
                case 1:
                    return NumberClassStyle;
                case 2:
                    {
                        switch (filter.NameDb)
                        {
                            case "team_home_id":
                                return ListHomeClassStyle;
                            default:
                                return ListAwwayClassStyle;
                        }
                    }
                case 3:
                    return TimeClassStyle;

                case 4:
                    return ListCountryStyle;
                case 5:
                    return ListLegueStyle;
                case 6:
                    return ListSeasonStyle;
                default:
                    return null;
            }
        }
    }
}
