﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using Syncfusion.UI.Xaml.Grid.Helpers;
using XGApp.ViewModel;

namespace XGApp.Views
{
    /// <summary>
    /// Логика взаимодействия для StatistickFilter.xaml
    /// </summary>
    public partial class StatistickFilter : UserControl
    {
        public StatistickFilter()
        {
            InitializeComponent();
        }

        private void HandleUnchecked(object sender, RoutedEventArgs e)
        {
            if (sbobetBtn == null || pinnacleBtn == null)
                return;
            var btn = sender as ToggleButton;
            if (btn == null)
            {
                return;
            }
            if (btn.Content.ToString() == "Pinnacle")
            {
                sbobetBtn.IsChecked = true;
            }
            else
            {
                pinnacleBtn.IsChecked = true;
            }

        }

        private void HandleCheck(object sender, RoutedEventArgs e)
        {
            if (sbobetBtn == null || pinnacleBtn == null)
                return;
            var btn = sender as ToggleButton;
            if (btn == null)
            {
                return;
            }
            if (btn.Content.ToString() == "Pinnacle")
            {
                ((NavigationDrawerProperties)this.DataContext).ChangeStat("pin");
                sbobetBtn.IsChecked = false;
            }
            else
            {
                ((NavigationDrawerProperties)this.DataContext).ChangeStat("sbo");
                pinnacleBtn.IsChecked = false;
            }

        }



        private void ProfileButton_Click(object sender, RoutedEventArgs e)
        {

        }

        private void sfgridPerformance_CurrentCellValueChanged(object sender, Syncfusion.UI.Xaml.Grid.CurrentCellValueChangedEventArgs e)
        {
            var grid = sender as SfDataGrid;
            //getting GridCell
            var cell =
                (grid.SelectionController.CurrentCellManager.CurrentCell.Renderer as GridCellRendererBase)
                    .CurrentCellElement;

            if (cell != null)
            {
                //var vm = cell.DataContext as BasicResutl;
                ////assigned columnindex to the index property in OrderInfo
                //vm.DataIndex = e.RowColumnIndex.ColumnIndex;
                ////updates the current row index
                grid.UpdateDataRow(e.RowColumnIndex.RowIndex);
            }
        }
    }
}
